## 开发

__*002*__ 模块目录结构
> 可以利用odoo提供的脚手架工具生成模块(Module)
> ```shell
> ./odoo-bin scaffold （模块名） /（选择存放的目录）
> ```

```shell
|-Module
|   -controllers
|   -data
|   -demo
|   -doc
|   -i18n
|   -models
|   -report
|   -security
|   -static
|     |--description
|     |--src
|     |--img
|     |--tests
|   -test
|   -tests
|   -views
|   -wizard
|   -__init__.py
|   -__manifest__.py
|   -README.md
```
**說明**：  
## <font color=liblue>**controllers**</font> 
自定义的控制器实现；主要用于控制前段网页的交互，尤其是路由（route）控制。

## <font color=liblue>**data**</font> 
初始化数据文件目录；主要用于初始化模块的一些数据，如模块的单据序号方式也在此目录下来定义。

## <font color=liblue>**demo**</font> 
模拟演示数据

## <font color=liblue>**doc**</font> 
模块说明文档

## <font color=liblue>**i18n**</font>   
国际化文档，存放各个国家语言的翻译PO文件，系统会自动查找对应的语言文件，如简体中文：zh_CN.po。

## <font color=liblue>**models**</font> 
模块中用到的对象模型，模型的业务逻辑代码等。


## <font color=liblue>**report**</font> 
模块中的报表模型或者相应的报表视图文件

## <font color=liblue>**security**</font> 
权限文件，通常有两个文件：ir.model.access.csv、security.xml  
ir.model.access.csv文件保存不同用户组对相应模型对象的增删改查的权限控制
security.xml文件中定义了不同的用户组及分类，如管理员组、用户组；用户组就是在ir.model.access.csv文件中被授权的对象。

## <font color=liblue>**static**</font> 
静态资源目录，一般有以下几个子目录：description、src、img
description：保持对模块的描述文件，如模块的图标（icon.png)、描述(index.html)，这些文件名都是固定的，图标最好用小点的规格（100*100px）；
src：此目录下放一些前端相关的静态资源如：js、css、images、xml；
img：此目录下放一些跟模块相关联的图片文件

## <font color=liblue>**views**</font> 
视图文件目录，此目录下的xml文件是跟modles目录下的模型对象相关的视图文件，如表单视图、列表视图、搜索视图、看板视图等等。

## <font color=liblue>**wizard**</font> 
向导视图目录，一般用于页面弹出的向导窗口；
向导模型在数据库中也会建立相应的数据库表，向导保存的是一些临时使用的数据，视图上多以弹出框形式展示，向导产生数据为临时数据不会长时间在数据库中保存，模型对象继承自models.TransientModel

## <font color=liblue>**test、tests**</font> 
测试模型，在开发环境下镜像单元测试









